program L_tL_para 
use sep

implicit none

integer                              :: n1,n2,n3,n4
integer                              :: nsx,nz,nx,nw,nxh,nzh
real                                 :: o1,o2,o3,o4
real                                 :: d1,d2,d3,d4 
real                                 :: auxi 
complex                              :: cauxi 
integer                              :: esize,iz,ix,ihz,ihx,isr,iw
complex, dimension(:,:,:)  , allocatable :: green
complex, dimension(:)      , allocatable :: aaaixz,aaajxz 
real,    dimension(:,:,:,:), allocatable :: LtL 
complex, dimension(:,:,:,:), allocatable :: MulGreen 

call sep_init()
call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call from_param('nxh',nxh,11) !allways odd 
call from_param('nzh',nzh,11) !allways odd 
nsx=n1
nz=n2
nx=n3
nw=n4
call to_history('n1',nz ); call to_history('d1',d2); call to_history('o1',o2) ; call to_history('label1',"z")
call to_history('n2',nx ); call to_history('d2',d3); call to_history('o2',o3) ; call to_history('label2',"mx")
call to_history('n3',nzh); call to_history('d3',d2); call to_history('o3',0.) ; call to_history('label3',"hz")
call to_history('n4',nxh); call to_history('d4',d3); call to_history('o4',0.) ; call to_history('label4',"hx")
call to_history('n5',nw ); call to_history('d5',d4); call to_history('o5',o4) ; call to_history('label5',"w")
call to_history('esize',4)
call sep_close()

call sep_begin_prog()
write(0,*)"nsx,nz,nx,nw",nsx,nz,nx,nw
write(0,*)"d1,d2,d3,d4",d1,d2,d3,n4
write(0,*)"o1,o2,o3,o4",o1,o2,o3,n4

allocate(green(nsx,nz,nx),LtL(nz,nx,nzh,nxh),MulGreen(nz,nx,nzh,nxh),aaaixz(nsx),aaajxz(nsx))



do iw=1,nw
  LtL=0.
  MulGreen=(0.,0.)
  write(0,*)"frequency",iw
   call sep_read(green)

   ! Computation of the second Sum
   do iz=1,nz
   do ix=1,nx
     aaaixz(1:nsx)=conjg(green(1:nsx,iz,ix)) 
     do ihz=1,nzh
     do ihx=1,nxh
       if (  (iz-(nzh-1)/2+ihz-1 >= 1  ) .and. (ix-(nxh-1)/2+ihx-1 >=1  ) .and. &
             (iz-(nzh-1)/2+ihz-1 <= nz ) .and. (ix-(nxh-1)/2+ihx-1 <= nx)) then
         aaajxz(1:nsx)=green(1:nsx,iz-(nzh-1)/2+ihz-1,ix-(nxh-1)/2+ihx-1)
       else
         aaajxz(1:nsx)=(0.,0.)
       endif
       do isr=1,nsx
         MulGreen(iz,ix,ihz,ihx)=MulGreen(iz,ix,ihz,ihx)+aaaixz(isr)*aaajxz(isr)
       enddo
     enddo
     enddo
   enddo
   enddo
   
   ! Computation of the Hessian
   do iz=1,nz
   do ix=1,nx
     aaaixz(1:nsx)=conjg(green(1:nsx,iz,ix)) 
     do ihz=1,nzh
     do ihx=1,nxh
       if (  (iz-(nzh-1)/2+ihz-1 >= 1  ) .and. (ix-(nxh-1)/2+ihx-1 >=1  ) .and. &
             (iz-(nzh-1)/2+ihz-1 <= nz ) .and. (ix-(nxh-1)/2+ihx-1 <= nx)) then
         aaajxz(1:nsx)=green(1:nsx,iz-(nzh-1)/2+ihz-1,ix-(nxh-1)/2+ihx-1)
       else
         aaajxz(1:nsx)=(0.,0.)
       endif
       do isr=1,nsx
         LtL(iz,ix,ihz,ihx)=LtL(iz,ix,ihz,ihx)+real( aaaixz(isr)*aaajxz(isr)*MulGreen(iz,ix,ihz,ihx) )
       enddo
     enddo
     enddo
   enddo
   enddo
   call sep_write(LtL)
enddo

deallocate(green,LtL,MulGreen,aaaixz,aaajxz)

call sep_end_prog()
end program L_tL_para
