program test 
use sep
use sparse_mapping

implicit none
real, dimension (:,:,:,:), pointer   :: Hcube
real, dimension (:,:)    , pointer   :: Hsp
integer                              :: n1,n2,n3,n4 ! nz nx (nhz nhx allways odd)
real                                 :: o1,o2,o3,o4 
real                                 :: d1,d2,d3,d4
integer                              :: esize,i,cont

call sep_init()

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call sp_cont ( n1,n2,n3,n4,cont )

call to_history('n1',cont); call from_history('d1',d1); call from_history('o1',o1)
call to_history('n2',3); call from_history('d2',d1); call from_history('o2',o1)
call to_history('n3',1); call from_history('d3',d1); call from_history('o3',o1)
call to_history('n4',1); call from_history('d4',d1); call from_history('o4',o1)

allocate(Hcube(n1,n2,n3,n4),Hsp(cont,3))
Hsp=0.
call sep_read(Hcube)                 ! Sep format Hessian matrix
call sp_mapp (Hcube,Hsp,n1,n2,n3,n4) ! Mapp Heesian matrix from Sep to sparse representation

do i=1,cont
 write(0,*),i,Hsp(i,1),Hsp(i,2),Hsp(i,3)
enddo

call sep_write(Hsp)
deallocate(Hcube,Hsp)

end program test 
