program Sparse_MxV_inv
use sep
use dottest 
use sparse_matmult 
use cgstep_mod
!use solver_smp_mod
use solver_mod_mio
use scaled_identity
use sparse_mapping

implicit none
real, dimension (:),     allocatable :: m_inv,m_mig
real, dimension (:,:,:,:), pointer   :: Hcube
real, dimension (:,:)    , pointer   :: Hsp
real, dimension (2)                  :: dot1,dot2
integer                              :: stat
logical                              :: adj,add
integer                              :: niter     ! iterations
real                                 :: eps       ! scaling parameter
real, dimension(:),      pointer     :: err       ! residual error per iteration
real, dimension(:),      pointer     :: res       ! final residual error
integer                              :: n1,n2,n3,n4 ! nz nx (nhz nhx allways odd)
real                                 :: o1,o2,o3,o4 
real                                 :: d1,d2,d3,d4
integer                              :: esize
integer                             :: i1,i2,i3,i4

call sep_init()

call from_history('n1',n1); call from_history('d1',d1); call from_history('o1',o1)
call from_history('n2',n2); call from_history('d2',d2); call from_history('o2',o2)
call from_history('n3',n3); call from_history('d3',d3); call from_history('o3',o3)
call from_history('n4',n4); call from_history('d4',d4); call from_history('o4',o4)
call from_history("esize",esize)

call from_param('eps',eps,.00001)
call from_param('niter',niter,10)

allocate(Hcube(n1,n2,n3,n4),Hsp(n1*n2*n3*n4,3))
call sep_read(Hcube)                 ! Sep format Hessian matrix
call sp_mapp (Hcube,Hsp,n1,n2,n3,n4) ! Mapp Heesian matrix from Sep to sparse representation
deallocate(Hcube)

allocate(m_inv(n1*n2),m_mig(n1*n2))
call sep_read(m_mig,"mig")  ! Target migration

call smatmult_init (Hsp)
write(0,*)"aqui estoy"
call dot_test(smatmult_lop,n1*n2,n1*n2,dot1,dot2)

!stat = smatmult_lop(.false.,.false.,m_mig, m_inv)
!write(0,*)'m_mig',m_mig
write(0,*)"aqui estoy"

call solver_reg(smatmult_lop,cgstep,identity_exec,n1*n2, m_inv, m_mig,niter,eps, &
                res=res, verb=.true. )

!call solver_smp(m=m_inv, d=m_mig, Fop=smatmult_lop,stepper=cgstep,niter=niter, verb=.true.)

call cgstep_close()

call sep_write(m_inv)

call to_history('n1',n1); call to_history('d1',d1); call to_history('o1',o1) ; call to_history('label1',"z" )
call to_history('n2',n2); call to_history('d2',d2); call to_history('o2',o2) ; call to_history('label2',"mx")
call to_history('n3',1); call to_history('d3',d2); call to_history('o3',0.) ; call to_history('label3'," " )
call to_history('n4',1); call to_history('d4',d3); call to_history('o4',0.) ; call to_history('label4'," ")
deallocate(m_inv,m_mig,Hsp)

end program Sparse_MxV_inv
